require ("global")

--[[

Quest Script

Name: 	Stone Deaf
Code: 	Etc2g2
Id: 	110666
Prereq: Level 18, Any DoW/DoM

]]

-- Sequence Numbers
SEQ_000	= 0;  -- Kill Canopy Galagos.
SEQ_001	= 1;  -- Talk to Kinborow.

-- Actor Class Ids
ENPC_KINBOROW 		= 1000509;
BNPC_CANOPY_GALAGOS	= 2100502;

-- Quest Markers
MRKR_GALAGOS_AREA	= 11066602;
MRKR_KINBOROW		= 11066601;

-- Counters
COUNTER_QUESTITEM	= 0;

-- Quest Details
OBJECTIVE_ITEMID	= 11000163;
OBJECTIVE_AMOUNT	= 5;

function onStart(player, quest)	
	quest:StartSequence(SEQ_000);
end

function onFinish(player, quest)
end

function onStateChange(player, quest, sequence)	
	if (sequence == SEQ_ACCEPT) then
		quest:SetENpc(ENPC_KINBOROW, QFLAG_PLATE);
	elseif (sequence == SEQ_000) then
        quest:SetENpc(ENPC_KINBOROW);
		quest:SetENpc(BNPC_CANOPY_GALAGOS);
	elseif (sequence == SEQ_001) then
		quest:SetENpc(ENPC_KINBOROW, QFLAG_REWARD);
	end	
end

function onTalk(player, quest, npc, eventName)
	local npcClassId = npc.GetActorClassId();
	local seq = quest:GetSequence();
    
	-- Offer the quest
	if (npcClassId == ENPC_KINBOROW and seq == SEQ_ACCEPT) then
		local questAccepted = callClientFunction(player, "delegateEvent", player, quest, "processEventStart");
		if (questAccepted == 1) then
			player:AcceptQuest(quest);
		end
		player:EndEvent();
		return;	
	-- Quest Progress
	elseif (seq == SEQ_000) then
        if (npcClassId == ENPC_KINBOROW) then
            callClientFunction(player, "delegateEvent", player, quest, "processEventFree");
		end
	--Quest Complete
	elseif (seq == SEQ_001) then
		if (npcClassId == ENPC_KINBOROW) then
			callClientFunction(player, "delegateEvent", player, quest, "processEventClear");
			callClientFunction(player, "delegateEvent", player, quest, "sqrwa", 200, 1, 1, 9);
            player:CompleteQuest(quest);
		end
	end
	
	quest:UpdateENPCs();	
	player:EndEvent();
end

function onKillBNpc(player, quest, bnpc)
	if (quest:GetSequence() == SEQ_000 and bnpc == BNPC_CANOPY_GALAGOS) then
		local counterAmount = quest:GetData():IncCounter(COUNTER_QUESTITEM);
		attentionMessage(player, 25226, OBJECTIVE_ITEMID, 1, counterAmount, OBJECTIVE_AMOUNT); -- You obtain <item> (X of Y)
        if (counterAmount >= OBJECTIVE_AMOUNT) then
			attentionMessage(player, 25225, quest:GetQuestId()); -- Objectives complete!
			quest:StartSequence(SEQ_001);
		end
	end
end

function getJournalInformation(player, quest)
	return quest:GetData():GetCounter(COUNTER_QUESTITEM);
end

function getJournalMapMarkerList(player, quest)
    local sequence = quest:getSequence();
    
    if (sequence == SEQ_000) then
		return MRKR_GALAGOS_AREA;
    elseif (sequence == SEQ_001) then
        return MRKR_KINBOROW;
    end
end